	include	"flib.h"
	include	"hexlib.h"
	include	"tios.h"
	include	"irlib.h"
	xdef	_main
	xdef	_comment
;***********************************************************
WrtStr	macro
	move.w	\3,-(a7)
	pea	\4(pc)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr	tios::DrawStrXY
	lea	10(a7),a7
	endm
;***********************************************************
_main:
	clr		d6
	move.w	#$690,d6
	jsr		flib::zap_screen
	move.w	#2,-(a7)
	jsr		tios::FontSetSys
	lea		2(a7),a7
	WrtStr	#0,#00,#1,Text1
	WrtStr	#0,#10,#1,Text2
	WrtStr	#0,#20,#1,Text3
	WrtStr	#0,#39,#1,Text4
Loop:

	move.l	d6,d0
	move.l	#5,d1
	move.l	#13,d2
	move.l	#2,d4
	jsr		hexlib::put_hex

;Delay:
;	move.l	#$5fff,d0
;DeLoop:
;	nop
;	dbra	d0,DeLoop

	clr		d0
	jsr		flib::idle_loop
	cmp		#344,d0				; down
	beq		dec_app
	cmp		#338,d0				; up
	beq		inc_app
	cmp		#257,d0				; del=257
	beq		send_code
	cmp		#264,d0				; exit
	beq		Exit
	bra		Loop
dec_app:
	cmp.w	#0,d6
	beq		Loop
	sub.w	#1,d6
	bra		Loop
inc_app:
	cmp.w	#$fff,d6
	beq		Loop
	add.w	#1,d6
	bra		Loop
Exit:
	jsr		tios::reset_link
	rts
;***********************************************************
; Routine pour convertir la commande  
;***********************************************************
; d1 nbr de bits
; d2 = 12 bits  convertir
send_code:
	movem	d0-d2/d6/a0,-(a7)
	lea		code(PC),a0
	move	#7,d1

Effloop:
	move.w	#0,(a0)+
	dbra	d1,Effloop

	lea	code(PC),a0
	clr		d0
	clr		d1
	move.b	#%00111100,d0
	move.b	#5,d1			; on a dj la tte
	move.l	#11,d2			; 12 bits  convertir

	move.l	d6,-(a7)

	bsr convert				; ok

	move.l	d1,-(a7)	; sauve d1
decal:
	addi.b	#1,d1		
	cmp.b	#8,d1
	beq		findecal
	asl.b	#1,d0
	bra		decal
findecal:
	or.b	d0,(a0)

	clr		d0
	move.w	#39,d2
	move.l	(a7)+,d1
lap:
	addi.b	#1,d1
	cmp.b	#8,d1
	bne		pasinca0
	clr d1
	or.b	d0,(a0)+
pasinca0:
	dbra.w	d2,lap

	move.w	#3,d2
head2:
	ori		#1,d0
	addi.b	#1,d1
	bsr		verif
	asl.b	#1,d0
	dbra.w	d2,head2
	addi.b	#1,d1
	bsr		verif
	asl.b	#1,d0


	move.l	(a7)+,d6
	move.w	#11,d2			; 12 bits  convertir
	bsr convert

decal2:
	addi.b	#1,d1
	cmp.b	#8,d1
	beq		findecal2
	asl.b	#1,d0
	bra		decal2
findecal2:
	or.b	d0,(a0)

	move.l	(Sony),d3
	move.w	#31,d4
	jsr		irlib::PutLink

	lea		code(PC),a0
	move	#15,d5
;	move.l	#7,d1
;	move.l	#0,d2
sendloop:
	move.b	(a0)+,d3
;	move.l	d3,d0
;	cmp.l	#19,d5
;	bne		nonewline1
;	add.l	#1,d1
;	move.l	#0,d2
;nonewline1
;	cmp.l	#9,d5
;	bne		nonewline2
;	add.l	#1,d1
;	move.l	#0,d2
;nonewline2:
;	move.l	#1,d4
;	add.l	#1,d2
;	jsr		hexlib::put_hex

	jsr		irlib::PutByte
	dbra	d5,sendloop
	movem	(a7)+,d0-d2/d6/a0
	bra		Loop
;****************************
convert:
	btst.b	#0,d6
	beq		code0
code1:
	ori.b	#1,d0
	addi.b	#1,d1
	bsr		verif
	asl.b	#1,d0

	ori.b	#1,d0
	addi.b	#1,d1
	bsr		verif
	asl.b	#1,d0

	addi.b	#1,d1
	bsr		verif
	asl.b	#1,d0

	bra		suite
code0:
	ori.b	#1,d0
	addi.b	#1,d1
	bsr		verif
	asl.b	#1,d0

	addi.b	#1,d1
	bsr		verif
	asl.b	#1,d0

suite:
	ror.w	#1,d6
	dbra	d2,convert
	rts
verif:
	cmp.b	#8,d1
	bne		v_end
	or.b	d0,(a0)+
	clr		d0
	clr		d1
v_end:
	rts


;***********************************************************
Text1:	dc.b	"Device   : Up/Down",0
Text2:	dc.b	"Command  : Left/Right",0
Text3:	dc.b	"Send     : Del",0
Text4:	dc.b	"Command  : $",0
Sony:	dc.l	$130f1610
code:	dc.w	0,0,0,0,0,0,0,0
_comment	dc.b	"v1.0 by A.MERCIER",0
	end
